if(!isObject(AmmoLockerOpenSound))
{
	datablock AudioProfile(AmmoLockerOpenSound)
	{
		filename = "./lockeropen.wav";
		description = AudioClose3d;
		preload = true;
	};
}

if(!isObject(AmmoLockerCloseSound))
{
	datablock AudioProfile(AmmoLockerCloseSound)
	{
		filename = "./lockerclose.wav";
		description = AudioClose3d;
		preload = true;
	};
}

datablock ItemData(RHealthLockerItem)
{
	category = "Item";  // Mission editor category
	//className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./HealthLocker15.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "";
	iconName = "";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	image = "";
	canDrop = true;
};
datablock fxDTSBrickData (BrickLockerData)
{
	brickFile = "./LockerBrick.blb";
	category = "Special";
	subCategory = "Interactive";
	uiName = "Health Locker";
	iconName = "Add-Ons/Brick_HealthLocker/Icon_HealthLocker";
	indestructable = 1;
};

function BrickLockerData::onloadPlant(%data, %brick, %a, %b)
	{
	BrickLockerData::OnPlant(%data, %brick, %a, %b);
	}

function BrickLockerData::onPlant(%data, %brick, %a, %b)
{
  %brick.setrendering(0);
  %attach = new Item()
	{
		datablock = "RHealthLockerItem";
		static = 1;
	};
	%attach.spawnbrick = %brick;
  %attach.settransform(vectoradd(%brick.gettransform(),"0 0 -1.42") SPC getwords(%brick.gettransform(),3,6));
  %brick.attachment = %attach;

	%brick.LockerSupplyCount = 0;
}

function BrickLockerData::onRemove(%data, %brick)
{
   if(isObject(%brick.attachment))
	{
      %brick.attachment.delete();
cancel(%brick.attachment.HealthlockerAnim);
cancel(%brick.attachment.Evalcrashes);
	}
      parent::OnRemove(%data,%brick);
}

function BrickLockerData::onDeath(%data, %brick)
{
   if(isObject(%brick.attachment))
	{
      %brick.attachment.delete();
	}
      parent::OnDeath(%data,%brick);
}

function HealthlockerAnim(%obj,%oc)
{
	if(%oc == 1)
	{
		%obj.playaudio(2,AmmoLockerOpenSound);
		%obj.playthread(1,open);
		%obj.isopen = 1;
		
	}
	if(%oc == 0)
	{
		%obj.playthread(1,close);
		cancel(%obj.slowd);
		%obj.isopen = 0;
		%obj.isshutting = 1;
		%obj.slowd = schedule(600,0,Evalcrashes,%obj);
		%obj.playaudio(2,AmmoLockerCloseSound);
	}
}
function EvalCrashes(%obj)
{
	%obj.isshutting= 0;
}

package HealthLockerColFunctions
{
function Armor::onCollision(%this,%obj,%col,%a,%b,%c,%d)
	{
		if(%col.getdatablock().getname() $= "RHealthLockerItem" && %obj.getclassname() $= "Player" && %obj.getstate() !$= "Dead")
		{
				if(isObject(getMiniGamefromObject(%obj,%col)) && $HealthLocker::Supplies && %col.LockerSupplyCount == $HealthLocker::SupplyAmount && %obj.getdamagelevel() > 0)//Functions if supplycount equals supply amount
			{
		%obj.client.centerprint("<just:center><font:impact:40>\c6Health Supplies:" @ "<br>\c0"SPC $HealthLocker::SupplyAmount-%col.LockerSupplyCount,1);//Centerprint to the player the supply ammount
        	}

			if($HealthLocker::Supplies && %obj.getdamagelevel() > 0 && %col.isshutting != 1 && %col.lasttouch+$HealthLocker::AcquireDelay < getsimtime() && %col.LockerSupplyCount < $HealthLocker::SupplyAmount)//If supplies is enabled
			{
				%col.lasttouch = getsimtime();
				%obj.addhealth($HealthLocker::HealAmount);
				%obj.playthread(2, plant);
				%obj.emote(HealImage, 1);
				serverPlay3D(PrintFireSound,%obj.getPosition());

				if(isObject(getMiniGamefromObject(%obj,%col)))
				{

				%col.LockerSupplyCount += 1;

				if(%col.LockerSupplyCount < $HealthLocker::SupplyAmount)//Functions if supplycount is less than supply amount
					{
				%obj.client.centerprint("<just:center><font:impact:40>\c6Health Supplies:" @ "<br>\c2"SPC $HealthLocker::SupplyAmount-%col.LockerSupplyCount,1);//Centerprint to the player the supply ammount
        			}

				}

			if(%col.isopen == 0)
				{
					HealthlockerAnim(%col,1);
				}
				cancel(%col.closedoor);
				%col.closedoor = schedule(600,0,HealthlockerAnim,%col,0);
			}

			if(!$HealthLocker::Supplies && %obj.getdamagelevel() > 0 && %col.isshutting != 1 && %col.lasttouch+$HealthLocker::AcquireDelay < getsimtime())//If supplies is disabled
			{
				%col.lasttouch = getsimtime();
				%obj.addhealth($HealthLocker::HealAmount);
				%obj.playthread(2, plant);
				%obj.emote(HealImage, 1);
				serverPlay3D(PrintFireSound,%obj.getPosition());

			if(%col.isopen == 0)
				{
					HealthlockerAnim(%col,1);
				}
				cancel(%col.closedoor);
				%col.closedoor = schedule(600,0,HealthlockerAnim,%col,0);
			}
		return;
		}
	Parent::onCollision(%this,%obj,%col,%a,%b,%c,%d);
	}

};
activatePackage(HealthLockerColFunctions);