datablock AudioProfile(AmmoLockerOpenSound)
{
	filename = "./lockeropen.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(AmmoLockerCloseSound)
{
	filename = "./lockerclose.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(AmmoCrateSound)
{
	filename = "./AmmoCrateSound.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock ItemData(RAmmoCrateItem)
{
	category = "Item";  // Mission editor category
	//className = "Item"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./RotCoAmmoCrate2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "";
	iconName = "";
	doColorShift = false;
	isSwepAmmoCrate = 1;

	 // Dynamic properties defined by the scripts
	image = "";
	canDrop = true;
};
datablock fxDTSBrickData (BrickAmmoCrateData)
{
	brickFile = "./AmmoCrateBrick.blb";
	category = "Special";
	subCategory = "Interactive";
	uiName = "Ammo Crate";
	iconName = "add-ons/Brick_Sweps_AmmoCrate/Icon_AmmoCrate";
	indestructable = 1;
	isSWepAmmoCrate = 1;
};

function BrickAmmoCrateData::onPlant(%data, %brick, %a, %b)
{
	%attach = new Item()
	{
		datablock = "RAmmoCrateItem";
		static = 1;
	};

	%brick.setrendering(0);
	%attach.spawnbrick = %brick;
	%attach.settransform(vectoradd(%brick.gettransform(),"0 0 -0.4") SPC getwords(%brick.gettransform(),3,6));
	%brick.attachment = %attach;

	%brick.AmmoSupplyCount = 0;
}

function BrickAmmoCrateData::onloadPlant(%data, %brick, %a, %b)
{
	BrickAmmoCrateData::onPlant(%data, %brick, %a, %b);
}

function BrickAmmoCrateData::onRemove(%data, %brick)
{
   if(isObject(%brick.attachment))
	{
      %brick.attachment.delete();
	}
      Parent::OnRemove(%data,%brick);
}


function BrickAmmoCrateData::onDeath(%data, %brick)
{
   BrickAmmoCrateData::onRemove(%data, %brick);
}

function AmmoCrateAnim(%obj,%oc)
{
	if(isObject(%obj))
	{
		if(%oc == 1)
		{
			%obj.playaudio(2,AmmoLockerOpenSound);
			%obj.playthread(1,open);
			%obj.isopen = 1;
		}

		if(%oc == 0)
		{
			%obj.playthread(1,close);
			cancel(%obj.slowd);
			%obj.isopen = 0;
			%obj.isshutting = 1;
			%obj.slowd = schedule(500,0,AmmoEvalcrashes,%obj);
			%obj.playaudio(2,AmmoLockerCloseSound);
		}
	}
}

function toggleCloseOpen(%col)
{
	if(%col.isopen == 0)
	{
		AmmoCrateAnim(%col,1);
	}
	cancel(%col.closedoor);
	%col.closedoor = schedule(2000,0,AmmoCrateAnim,%col,0);
}

function AmmoEvalCrashes(%obj)
{
	%obj.isshutting= 0;
	if(isObject(%obj.spawnBrick.textShape))
	{
	%obj.spawnbrick.textshape.delete();
	}
}

function GiveAmmo(%obj,%col)
{
	%item = %obj.getmountedimage(0).item;
	%ammoType = %item.sAmmoType;
	%ammo = %item.sAmmo;
	%max = swolammo_getMax(%ammoType);
	%ammoused = %Ammo-%obj.sAmmo[nameToId(%item)];
	%ammoneeded = %obj.sReserve[%ammoType];//-%ammoused;

	toggleCloseOpen(%col);
	%obj.playthread(2, plant);
	serverPlay3D(ammocratesound,%obj.getPosition());
	serverPlay3D(pickupAmmo @ getRandom(1,2) @ Sound,%col.getPosition());

	if($SWepCrate::AmmoAmount == 0)
	%obj.sReserve[%ammoType] = %max+%ammoused;

	else 
	{
	%obj.sReserve[%ammoType] += %ammo*2;
  	%obj.sReserve[%ammoType] = mClamp(%obj.sReserve[%ammoType], 0, %max + %ammoused);
	}
	sAmmo_display(%obj);
	
}

function AmmoShapeName(%brick,%shapename)
{
		if(isObject(%brick.textShape))
	{
		%brick.textShape.setShapeName(%shapename);
		%brick.textShape.setShapeNameColor("1 1 1 1");        
		%brick.textShape.setShapeNameDistance(25);
	}
	else
	{
	%brick.textShape = new StaticShape()
	{
		datablock = BrickTextEmptyShape;
		position = vectorAdd(%brick.getPosition(),"0 0" SPC %brick.getDatablock().brickSizeZ/9 + "0.166");
		scale = "0.1 0.1 0.1";
	};
			%brick.textShape.setShapeName(%shapename);
			%brick.textShape.setShapeNameColor("1 1 1 1");        
			%brick.textShape.setShapeNameDistance(25);
	}
}

package SwepCrateColFunctions
{
function Armor::onCollision(%this,%obj,%col)
{
	if(%obj.getstate() $= "Dead")
	return;

	if(%col.getdatablock().getname() $= "RAmmoCrateItem")
	{
		if(%obj.lasttouch+$SwepCrate::AcquireDelay < getsimtime())
		%obj.lasttouch = getsimtime();
		
		%item = %obj.getmountedimage(0).item;
		%ammoType = %item.sAmmoType;
		%ammo = %item.sAmmo;
		%max = swolammo_getMax(%ammoType);
		%ammoused = %Ammo-%obj.sAmmo[nameToId(%item)];
		%ammoneeded = %obj.sReserve[%ammoType];//-%ammoused;
	
		if(%ammoneeded < %max && %col.isshutting !$= 1)
		{
			if($SwepCrate::Supplies) //If supplies is enabled
			{
				if(isObject(getMiniGamefromObject(%obj,%col)))
				{
					%brick = %col.spawnbrick;

					if(%col.AmmoSupplyCount < $SwepCrate::SupplyAmount)//Functions if supplycount is greater than or equal to supply amount (Empty)
					{
						GiveAmmo(%obj,%col);
						toggleCloseOpen(%col);

						if(%ammoneeded < %max-%ammo)
						{
							%col.AmmoSupplyCount += 1;
							%col.AmmoSupplyCount = mClamp(%col.AmmoSupplyCount, 0, $SwepCrate::SupplyAmount);
						}
						else
						{
							%col.AmmoSupplyCount += 0.1;
						}
					
						AmmoShapeName(%brick,"Supplies:" SPC $SwepCrate::SupplyAmount-%col.AmmoSupplyCount);
					}
					else//Give ammo and stuff
					{
						AmmoShapeName(%brick,"Supplies: 0");
					}	
				}
				else GiveAmmo(%obj,%col);
			}
			else//Do everything else BESIDES taking away supplies
			{
				GiveAmmo(%obj,%col);
			}
		}
   	}
	else return Parent::onCollision(%this,%obj,%col);
}
};
activatepackage(SwepCrateColFunctions);