%error = ForceRequiredAddOn("Weapon_SWeps");

if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Brick_SWeps_AmmoCrate - required add-on Weapon_SWeps not found");
}
else
{
   exec("./brick_SWeps_ammocrate.cs");
   exec("./support_bricktext.cs"); 
}

if(isFunction(registerPreferenceAddon))//Function for BLG preferences
{
	registerPreferenceAddon("Brick_SWeps_AmmoCrate", "SWep Ammo Crate", "box");

	new ScriptObject(Preference)
	{
		className      = "SWepAmmoCrate";

		addon          = "Brick_SWeps_AmmoCrate";
		category       = "SWep Ammo Crate";
		title          = "Limited supplies (Minigame only)";

		type           = "bool";
		params         = "";

		variable       = "$SWepCrate::Supplies";

		defaultValue   = "1";

		updateCallback = "";
		loadCallback   = "";

		hostOnly       = false;
		secret         = false;

		loadNow        = false;
		noSave         = false;
		requireRestart = false;
	};


			new ScriptObject(Preference)
	{
		className      = "SWepAmmoCrate";

		addon          = "Brick_SWeps_AmmoCrate";
		category       = "SWep Ammo Crate";
		title          = "Supply amount";

		type           = "num";
		params         = "0 100 0";

		variable       = "$SWepCrate::SupplyAmount";

		defaultValue   = "25";

		updateCallback = "";
		loadCallback   = "";

		hostOnly       = false;
		secret         = false;

		loadNow        = false;
		noSave         = false;
		requireRestart = false;
	};

				new ScriptObject(Preference)
	{
		className      = "SWepAmmoCrate";

		addon          = "Brick_SWeps_AmmoCrate";
		category       = "SWep Ammo Crate";
		title          = "Acquire delay (ms)";

		type           = "num";
		params         = "0 750 0";

		variable       = "$SWepCrate::AcquireDelay";

		defaultValue   = "500";

		updateCallback = "";
		loadCallback   = "";

		hostOnly       = false;
		secret         = false;

		loadNow        = false;
		noSave         = false;
		requireRestart = false;
	};

	new ScriptObject(Preference)
	{
		className      = "SWepAmmoCrate";

		addon          = "Brick_SWeps_AmmoCrate";
		category       = "SWep Ammo Crate";
		title          = "Ammo Amount";

		type           = "dropdown";
		params         = "Max 0 Increment 1";

		variable       = "$SWepCrate::AmmoAmount";

		defaultValue   = "Max 0";

		updateCallback = "";
		loadCallback   = "";

		hostOnly       = false;
		secret         = false;

		loadNow        = false;
		noSave         = false;
		requireRestart = false;
	};
}

else	//If BLG isn't installed
{
	$SWepCrate::AmmoAmount = 0;
	$SWepCrate::Supplies = 1;
	$SWepCrate::SupplyAmount = 25;
	$SWepCrate::AcquireDelay = 500;
}

registerOutputEvent(fxDTSBrick, "resetCrateAmmo");

function fxDTSbrick::resetCrateAmmo(%brick)
{
    if(%brick.attachment.getdatablock().getname() $= "RAmmoCrateItem")//Find if a brick's attachment is RAmmoCrateItem
    {
       %brick.attachment.AmmoSupplyCount = 0;//It seems counterintuitive to set it to 0, but that's how it works.
	   AmmoShapeName(%brick,"Supplies:" SPC $SwepCrate::SupplyAmount-%col.AmmoSupplyCount);
    }
}