exec("./support_apsys.cs");
new ScriptObject(SavedItemList)
{
	class = ApSys;
	dataFile = "config/server/saveditems.dat";
};
SavedItemList.addValue("Items","string 255");
SavedItemList.loadData();
function Player::saveItems(%player)
{
	%client = %player.client;
	if(isObject(%client) && isObject(%player))
	{
		%cdata = SavedItemList.getData(%client.BL_ID,1);
		%cdata.setValue("Items","");
		for(%i=0;%i<%player.getDatablock().maxTools;%i++)
		{
			if(%list $= "" && isObject(%player.tool[%i]))
			{
				%list = %player.tool[%i].getName();
			}
			else if(%list !$= "" && isObject(%player.tool[%i]))
			{
				%list = %list TAB %player.tool[%i].getName();
			}
		}
		%cdata.setValue("Items",%list);
	}
}
function Player::loadItems(%player)
{
	%client = %player.client;
	if(isObject(%client) && isObject(%player))
	{
		%cdata = SavedItemList.getData(%client.BL_ID,1);
		%itemlist = %cdata.getValue("Items");
		%itemcount = getFieldCount(%itemlist);
		%player.clearTools();
		if(%player.getDatablock().maxTools >= %itemcount)
		{
			for(%i=0;%i<%itemcount;%i++)
			{
				%itemname = getField(%itemlist,%i);
				%itemdb = nameToID(%itemname);
				if(isObject(%itemdb))
				{
					%player.tool[%i] = %itemdb;
					%player.weaponCount++;
					messageClient(%client,'MsgItemPickup','',%i,%itemdb);
				}
			}
			return;
		}
	}
}
package Event_ItemSaving
{
	function GameConnection::onClientLeaveGame(%client)
	{
		SavedItemList.saveData();
		Parent::onClientLeaveGame(%client);
	}
	function onExit()
	{
		SavedItemList.saveData();
		Parent::onExit();	
	}
};
activatePackage(Event_ItemSaving);
registerOutputEvent("Player", "saveItems", "", 0);
registerOutputEvent("Player", "loadItems", "", 0);