function initTireSearch()
{
	echo("Finding tire and spring datablocks..");

	%tires = 0;
	%springs = 0;

	%count = DatablockGroup.getCount();
	for(%i = 0; %i < %count; %i++)
	{
		%data = DatablockGroup.getObject(%i);
		if((%name = %data.getName()) $= "") //no blank object names pls
			continue;

		if(%data.getClassName() $= "WheeledVehicleTire") //is it a tire??
		{
			$Vehicle::Wheel[%tires] = %name;
			if(%tireList $= "")
				%tireList = %name SPC %tires;
			else
				%tireList = %tireList SPC %name SPC %tires;

			%tires++;
		}
		else if(%data.getClassName() $= "WheeledVehicleSpring") //or is it a spring??
		{
			$Vehicle::Spring[%springs] = %name;
			if(%springList $= "")
				%springList = %name SPC %springs;
			else
				%springList = %springList SPC %name SPC %springs;

			%springs++;
		}
	}

	
	if(%springs > 0)
	{
		registerOutputEvent("Vehicle", "setWheelSprings", "list " @ %springList TAB "int -1 10 -1");
		registerOutputEvent("fxDtsBrick", "setVehicleSprings", "list " @ %springList TAB "int -1 10 -1");
	}

	if(%tires > 0)
	{
		registerOutputEvent("Vehicle", "setWheels", "list " @ %tireList TAB "int -1 10 -1");
		registerOutputEvent("fxDtsBrick", "setVehicleWheels", "list " @ %tireList TAB "int -1 10 -1");
	}

	echo("Found " @ %tires @ " tire" @ (%tires != 1 ? "s" : "") @ " and " @ %springs @ " spring" @ (%springs != 1 ? "s" : "")); //some people use SPC but @ is faster :D
}
schedule(0, 0, initTireSearch);

function Vehicle::setWheels(%vehicle, %wheelData, %slot)
{
	if(%wheelData == mFloor(%wheelData))
		%wheelData = $Vehicle::Wheel[%wheelData];

	%data = %vehicle.getDatablock();
	if(!isObject(%wheelData) || %wheelData.getClassName() !$= "WheeledVehicleTire")
		%wheelData = %data.defaultTire;

	if(!isObject(%wheelData))
		return;

	if(%data.numWheels $= "") //what could go wrong
	{
		%data.hadNoWheels = 1;
		%data.numWheels = 4;
		%data.numMountPoints = 1;
	}

	if(%slot >= 0)
	{
		if(%slot >= %data.numWheels)
			%slot = %data.numWheels-1;

		%vehicle.setWheelTire(%slot, %wheelData);
	}
	else
	{
		for(%i = 0; %i < %data.numWheels; %i++)
			%vehicle.setWheelTire(%i, %wheelData);
	}
}

function Vehicle::setWheelSprings(%vehicle, %springData, %slot)
{
	if(%springData == mFloor(%springData))
		%springData = $Vehicle::Spring[%springData];

	%data = %vehicle.getDatablock();
	if(!isObject(%springData) || %springData.getClassName() !$= "WheeledVehicleSpring")
		%springData = %data.defaultTire;

	if(!isObject(%springData))
		return;

	if(%data.numWheels $= "") //what could go wrong
	{
		%data.hadNoWheels = 1;
		%data.numWheels = 4;
		%data.numMountPoints = 1;
	}

	if(%slot >= 0)
	{
		if(%slot >= %data.numWheels)
			%slot = %data.numWheels-1;

		%vehicle.setWheelSpring(%slot, %springData);
	}
	else
	{
		for(%i = 0; %i < %data.numWheels; %i++)
			%vehicle.setWheelSpring(%i, %springData);
	}
}

function fxDtsBrick::setVehicleWheels(%brick, %wheelData, %slot)
{
	if(isObject(%vehicle = %brick.vehicle) && %vehicle.getClassName() !$= "AIPlayer")
		%vehicle.setWheels(%wheelData, %slot);
}

function fxDtsBrick::setVehicleSprings(%brick, %springData, %slot)
{
	if(isObject(%vehicle = %brick.vehicle) && %vehicle.getClassName() !$= "AIPlayer")
		%vehicle.setWheelSprings(%springData, %slot);
}